#ifndef CHIP_STM32G0XX_REGS_MMAP_H
#define CHIP_STM32G0XX_REGS_MMAP_H


/* CODE MEMORY */
#define CHIP_MEMRGN_ADDR_FLASH                0x08000000UL
#define CHIP_MEMRGN_ADDR_SYSMEM               0x1FFF0000UL
#define CHIP_MEMRGN_ADDR_OTP                  0x1FFF7000UL
#define CHIP_MEMRGN_ADDR_ENGINEERING_BYTES    0x1FFF7500UL
#define CHIP_MEMRGN_ADDR_OPTION_BYTES         0x1FFF7800UL

/* RAM */
#define CHIP_MEMRGN_ADDR_RAM                  0x20000000UL

/* Peripherals */
#define CHIP_MEMRGN_ADDR_APB1                 0x40000000UL
#define CHIP_MEMRGN_ADDR_APB2                 0x40010000UL
#define CHIP_MEMRGN_ADDR_AHB                  0x40020000UL
#define CHIP_MEMRGN_ADDR_IOPORT               0x50000000UL
#define CHIP_MEMRGN_ADDR_CM0_INTERNAL         0xE0000000UL


/* Адреса портов */
#define CHIP_MEMRGN_ADDR_IOPORT_N(n)          (CHIP_MEMRGN_ADDR_IOPORT + (0x400*n))
#define CHIP_MEMRGN_ADDR_IOPORT_GPIOA         CHIP_MEMRGN_ADDR_IOPORT_N(0)
#define CHIP_MEMRGN_ADDR_IOPORT_GPIOB         CHIP_MEMRGN_ADDR_IOPORT_N(1)
#define CHIP_MEMRGN_ADDR_IOPORT_GPIOC         CHIP_MEMRGN_ADDR_IOPORT_N(2)
#define CHIP_MEMRGN_ADDR_IOPORT_GPIOD         CHIP_MEMRGN_ADDR_IOPORT_N(3)
#define CHIP_MEMRGN_ADDR_IOPORT_GPIOE         CHIP_MEMRGN_ADDR_IOPORT_N(4)
#define CHIP_MEMRGN_ADDR_IOPORT_GPIOF         CHIP_MEMRGN_ADDR_IOPORT_N(5)

/* Адреса блоков периферии */
#define CHIP_MEMRGN_ADDR_PERIPH_TIM2          (CHIP_MEMRGN_ADDR_APB1 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM3          (CHIP_MEMRGN_ADDR_APB1 + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM4          (CHIP_MEMRGN_ADDR_APB1 + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM6          (CHIP_MEMRGN_ADDR_APB1 + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM7          (CHIP_MEMRGN_ADDR_APB1 + 0x1400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM14         (CHIP_MEMRGN_ADDR_APB1 + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_RTC           (CHIP_MEMRGN_ADDR_APB1 + 0x2800)
#define CHIP_MEMRGN_ADDR_PERIPH_WWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x2C00)
#define CHIP_MEMRGN_ADDR_PERIPH_IWDG          (CHIP_MEMRGN_ADDR_APB1 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI2          (CHIP_MEMRGN_ADDR_APB1 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_I2S2          (CHIP_MEMRGN_ADDR_APB1 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI3          (CHIP_MEMRGN_ADDR_APB1 + 0x3C00)
#define CHIP_MEMRGN_ADDR_PERIPH_USART2        (CHIP_MEMRGN_ADDR_APB1 + 0x4400)
#define CHIP_MEMRGN_ADDR_PERIPH_USART3        (CHIP_MEMRGN_ADDR_APB1 + 0x4800)
#define CHIP_MEMRGN_ADDR_PERIPH_USART4        (CHIP_MEMRGN_ADDR_APB1 + 0x4C00)
#define CHIP_MEMRGN_ADDR_PERIPH_USART5        (CHIP_MEMRGN_ADDR_APB1 + 0x5000)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C1          (CHIP_MEMRGN_ADDR_APB1 + 0x5400)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C2          (CHIP_MEMRGN_ADDR_APB1 + 0x5800)
#define CHIP_MEMRGN_ADDR_PERIPH_USB           (CHIP_MEMRGN_ADDR_APB1 + 0x5C00)
#define CHIP_MEMRGN_ADDR_PERIPH_FDCAN1        (CHIP_MEMRGN_ADDR_APB1 + 0x6400)
#define CHIP_MEMRGN_ADDR_PERIPH_FDCAN2        (CHIP_MEMRGN_ADDR_APB1 + 0x6800)
#define CHIP_MEMRGN_ADDR_PERIPH_CRS           (CHIP_MEMRGN_ADDR_APB1 + 0x6C00)
#define CHIP_MEMRGN_ADDR_PERIPH_PWR           (CHIP_MEMRGN_ADDR_APB1 + 0x7000)
#define CHIP_MEMRGN_ADDR_PERIPH_DAC           (CHIP_MEMRGN_ADDR_APB1 + 0x7400)
#define CHIP_MEMRGN_ADDR_PERIPH_CEC           (CHIP_MEMRGN_ADDR_APB1 + 0x7800)
#define CHIP_MEMRGN_ADDR_PERIPH_LPTIM1        (CHIP_MEMRGN_ADDR_APB1 + 0x7C00)
#define CHIP_MEMRGN_ADDR_PERIPH_LPUART1       (CHIP_MEMRGN_ADDR_APB1 + 0x8000)
#define CHIP_MEMRGN_ADDR_PERIPH_LPUART2       (CHIP_MEMRGN_ADDR_APB1 + 0x8400)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C3          (CHIP_MEMRGN_ADDR_APB1 + 0x8800)
#define CHIP_MEMRGN_ADDR_PERIPH_LPTIM2        (CHIP_MEMRGN_ADDR_APB1 + 0x9400)
#define CHIP_MEMRGN_ADDR_PERIPH_USB_RAM1      (CHIP_MEMRGN_ADDR_APB1 + 0x9800)
#define CHIP_MEMRGN_ADDR_PERIPH_USB_RAM2      (CHIP_MEMRGN_ADDR_APB1 + 0x9C00)
#define CHIP_MEMRGN_ADDR_PERIPH_UCPD1         (CHIP_MEMRGN_ADDR_APB1 + 0xA000)
#define CHIP_MEMRGN_ADDR_PERIPH_UCPD2         (CHIP_MEMRGN_ADDR_APB1 + 0xA400)
#define CHIP_MEMRGN_ADDR_PERIPH_TAMP          (CHIP_MEMRGN_ADDR_APB1 + 0xB000)
#define CHIP_MEMRGN_ADDR_PERIPH_FDCAN_RAM     (CHIP_MEMRGN_ADDR_APB1 + 0xB400)

#define CHIP_MEMRGN_ADDR_PERIPH_SYSCFG        (CHIP_MEMRGN_ADDR_APB2 + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_VREFBUF       (CHIP_MEMRGN_ADDR_APB2 + 0x0030)
#define CHIP_MEMRGN_ADDR_PERIPH_SYSCFG_ITLINE (CHIP_MEMRGN_ADDR_APB2 + 0x0080)
#define CHIP_MEMRGN_ADDR_PERIPH_COMP          (CHIP_MEMRGN_ADDR_APB2 + 0x0200)
#define CHIP_MEMRGN_ADDR_PERIPH_ADC           (CHIP_MEMRGN_ADDR_APB2 + 0x2400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM1          (CHIP_MEMRGN_ADDR_APB2 + 0x2C00)
#define CHIP_MEMRGN_ADDR_PERIPH_SPI1          (CHIP_MEMRGN_ADDR_APB2 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_I2S1          (CHIP_MEMRGN_ADDR_APB2 + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_USART1        (CHIP_MEMRGN_ADDR_APB2 + 0x3800)
#define CHIP_MEMRGN_ADDR_PERIPH_USART6        (CHIP_MEMRGN_ADDR_APB2 + 0x3C00)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM15         (CHIP_MEMRGN_ADDR_APB2 + 0x4000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM16         (CHIP_MEMRGN_ADDR_APB2 + 0x4400)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM17         (CHIP_MEMRGN_ADDR_APB2 + 0x4800)
#define CHIP_MEMRGN_ADDR_PERIPH_DBG           (CHIP_MEMRGN_ADDR_APB2 + 0x5800)

#define CHIP_MEMRGN_ADDR_PERIPH_DMA1          (CHIP_MEMRGN_ADDR_AHB  + 0x0000)
#define CHIP_MEMRGN_ADDR_PERIPH_DMA2          (CHIP_MEMRGN_ADDR_AHB  + 0x0400)
#define CHIP_MEMRGN_ADDR_PERIPH_DMAMUX        (CHIP_MEMRGN_ADDR_AHB  + 0x0800)
#define CHIP_MEMRGN_ADDR_PERIPH_RCC           (CHIP_MEMRGN_ADDR_AHB  + 0x1000)
#define CHIP_MEMRGN_ADDR_PERIPH_EXTI          (CHIP_MEMRGN_ADDR_AHB  + 0x1800)
#define CHIP_MEMRGN_ADDR_PERIPH_FLASH         (CHIP_MEMRGN_ADDR_AHB  + 0x2000)
#define CHIP_MEMRGN_ADDR_PERIPH_CRC           (CHIP_MEMRGN_ADDR_AHB  + 0x3000)
#define CHIP_MEMRGN_ADDR_PERIPH_RNG           (CHIP_MEMRGN_ADDR_AHB  + 0x5000)
#define CHIP_MEMRGN_ADDR_PERIPH_AES           (CHIP_MEMRGN_ADDR_AHB  + 0x6000)





#endif // CHIP_STM32G0XX_REGS_MMAP_H
